Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.saxonica.deploy
Class CompiledClosure

    java.lang.Object
      net.sf.saxon.value.Value
          com.saxonica.deploy.CompiledClosure

All Implemented Interfaces:
  Serializable, Comparable, SequenceIterable, ValueRepresentation

Direct Known Subclasses:
  CompiledMemoClosure

    public class CompiledClosure

extends Value

A Closure represents a value that has not yet been evaluated: the value is represented by an expression, together with saved values of all the context variables that the expression depends on.

This Closure is designed for use when the value is only read once. If the value is read more than once, a new iterator over the underlying expression is obtained each time: this may (for example in the case of a filter expression) involve significant re-calculation.

The CompiledClosure class is similar to `Closure`, but is used only at run-time by queries that have been compiled into Java. It relies on the fact that Java provides a limited facility supporting closures: an anonymous inner class is allowed to reference local variables declared as "final", and these are automatically saved with the class instance so they are still available when the original stackframe disappears or changes. The code generator takes care to ensure that all variables that can be referenced from the inner class (specifically, those representing XPath variables as well as the context item) are held in variables that are declared final.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.value.Value
`EMPTY_CLASS_ARRAY, INDETERMINATE_ORDERING`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`CompiledClosure(SequenceIterator inputIterator, int primitiveType, int cardinality)`

Method Summary
`int` | `getCardinality()` Get the cardinality.
`ItemType` | `getItemType(TypeHierarchy th)` Get the static item type
`int` | `getLength()` Get the length of the value.
`boolean` | `isMultiValued()` Determine whether the value is multivalued, that is, whether it is a sequence that potentially contains more than one item
`SequenceIterator` | `iterate()` Evaluate the expression in a given context to return an iterator over a sequence
`Value` | `reduce()` Reduce a value to its simplest form.

Methods inherited from class net.sf.saxon.value.Value
`asItem, asItem, asIterator, asValue, checkPermittedContents, compareTo, convert, convertJavaObjectToXPath, convertToJava, effectiveBooleanValue, equals, fromItem, getCanonicalLexicalRepresentation, getIterator, getSchemaComparable, getStringValue, getStringValueCS, hashCode, itemAt, iterate, makeQNameValue, process, stringToNumber, toString`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### CompiledClosure

    public CompiledClosure(SequenceIterator inputIterator,
                           int primitiveType,
                           int cardinality)

Method Detail

### isMultiValued

    public boolean isMultiValued()

  Determine whether the value is multivalued, that is, whether it is a sequence that potentially contains more than one item

  Specified by:
    `isMultiValued` in class `Value`
  Returns:
    true if the value might contain more than one item, false if it definitely contains zero or one items

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Get the static item type

  Overrides:
    `getItemType` in class `Value`
  Parameters:
    `th` -
  Returns:
    for the default implementation: AnyItemType (not known)

### getCardinality

    public int getCardinality()

  Get the cardinality. This method is intended to be implemented in a subclass, but if it is not implemented, the fallback implementation simply returns `StaticProperty.ALLOWS_ZERO_OR_MORE`

  Overrides:
    `getCardinality` in class `Value`

### iterate

    public SequenceIterator iterate()
                             throws XPathException

  Evaluate the expression in a given context to return an iterator over a sequence

  Specified by:
    `iterate` in class `Value`
  Returns:
    an iterator over the sequence of items
  Throws:
    `XPathException` - if a dynamic error occurs. This is possible only in the case of values that are materialized lazily, that is, where the iterate() method leads to computation of an expression that delivers the values.

### reduce

    public Value reduce()
                 throws XPathException

  Reduce a value to its simplest form. If the value is a closure or some other form of deferred value such as a FunctionCallPackage, then it is reduced to a SequenceExtent. If it is a SequenceExtent containing a single item, then it is reduced to that item. One consequence that is exploited by class FilterExpression is that if the value is a singleton numeric value, then the result will be an instance of NumericValue

  Overrides:
    `reduce` in class `Value`
  Throws:
    `XPathException`

### getLength

    public int getLength()
                  throws XPathException

  Get the length of the value. Note: this consumes the iterator!

  Overrides:
    `getLength` in class `Value`
  Throws:
    `XPathException`

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.